// Type definitions for ./src/components/index.js
// Project: [LIBRARY_URL_HERE] 
// Definitions by: [YOUR_NAME_HERE] <[YOUR_URL_HERE]> 
// Definitions: https://github.com/borisyankov/DefinitelyTyped


import store from "../store";

export enum LayoutMode{
  LTR = 'ltr',
  LCR = 'lcr',
  TTB = 'ttb'
}

export enum Device{
  PC = 'pc',
  MOBILE = 'mobile',
  PAD = 'pad'
}

export enum Theme{
  DARK = 'dark',
  LIGHT = 'light',
  BLUE_SIDE = 'blue-side',
  DARK_SIDE = 'dark_side'
}

export enum ThemeColor{
  BLUE = 'theme_color_blue',
  RED = 'theme_color_red',
  PURPLE = 'theme_color_purple',
  CYAN = 'theme_color_cyan'
}

export declare interface UserInfo{
  nickName: string;
  avatar: string;
  [propsName: string]: any
}

export declare interface ActionItem{
  showSearch?: boolean;
  showMessage?: boolean;
  showFullScreen?: boolean;
  showRefresh?: boolean
}

interface StoreState{
  isCollapse: boolean,
  isFixedNavBar: boolean,
  layoutMode: LayoutMode,
  device: Device,
  theme: Theme,
  themeColor: ThemeColor,
  userInfo: UserInfo,
  actionItem: ActionItem
}

/**
 * 
 */
export declare interface LocalLayoutStore {
		
	/**
	 * 
	 */
  state: StoreState;
	install : /* install */ any;
  initPermissionRoute(routes: any),
  setUserInfo(userInfo: any),
  reset()
  isEmptyPermissionRoute():boolean
}

export default store;

/**
 * 
 * @param app 
 */
export declare function registerElement(app : any): void;

/**
 * 
 * @param app 
 */
export declare function registerComponents(app : any): void;

/**
 * 
 * @param Vue 
 * @param options 
 */
export declare function install(Vue : any, options : any): void;

export declare function useLayoutStore() : LocalLayoutStore;

export { default as Layout} from './Layout.vue'

declare module '@vue/runtime-core'{
  export interface ComponentCustomProperties {
    $layoutStore: LocalLayoutStore
  }
}
